<?php //$Id: backuplib.php,v 1.1.2.1 2009/12/28 19:12:14 diml Exp $
    //This php script contains all the stuff to backup/restore
    //coursetracking mods

    //This is the "graphical" structure of the coursetracking mod:
    //
    //                     coursetracking                                      
    //                 (CL,pk->id,files)
    //                          |
    //                     coursetracking_event
    //                  (UL, fk->coursetracking)
    //
    // Meaning: pk->primary key field of the table
    //          fk->foreign key to link with parent
    //          nt->nested field (recursive data)
    //          CL->course level info
    //          UL->user level info
    //          files->table may have files)
    //
    //-----------------------------------------------------------

    /**
    *
    */
    function coursetracking_backup_mods($bf, $preferences) {
        //Iterate over coursetracking table
        $trackers = get_records('coursetracking', 'course', $preferences->backup_course, 'id');
        if ($trackers) {
            print_object($trackers);
            foreach ($trackers as $tracker) {
                coursetracking_backup_one_mod($bf, $preferences, $tracker);
            }
        }
    }

    //This function executes all the backup procedure about this mod
    function coursetracking_backup_one_mod($bf,$preferences,&$tracker) {
        global $CFG;

        if (is_numeric($tracker)) {
            $tracker = get_record('coursetracking', 'id', $tracker);
        }

        $status = true; 

        //Start mod
        $status = $status && fwrite ($bf,start_tag("MOD",3,true));
        //Print coursetracking data
        fwrite ($bf,full_tag("ID",4,false,$tracker->id));
        fwrite ($bf,full_tag("MODTYPE",4,false,"coursetracking"));
        fwrite ($bf,full_tag("NAME",4,false,$tracker->name));
        fwrite ($bf,full_tag("DESCRIPTION",4,false,$tracker->description));
        fwrite ($bf,full_tag("COURSETRACKINGENABLE",4,false,$tracker->coursetrackingenable));
        fwrite ($bf,full_tag("TEACHERSSEETRACKERS",4,false,$tracker->teachersseetrackers));
        fwrite ($bf,full_tag("TIMESTARTENABLE",4,false,$tracker->timestartenable));
        fwrite ($bf,full_tag("TIMEENDENABLE",4,false,$tracker->timeendenable));
        fwrite ($bf,full_tag("TIMESTART",4,false,$tracker->timestart));
        fwrite ($bf,full_tag("TIMEEND",4,false,$tracker->timeend));
        fwrite ($bf,full_tag("CAPTURESTARTENABLE",4,false,$tracker->capturestartenable));
        fwrite ($bf,full_tag("CAPTUREENDENABLE",4,false,$tracker->captureendenable));
        fwrite ($bf,full_tag("CAPTURESTART",4,false,$tracker->capturestart));
        fwrite ($bf,full_tag("CAPTUREEND",4,false,$tracker->captureend));
        fwrite ($bf,full_tag("TRACKSTARTENABLE",4,false,$tracker->trackstartenable));
        fwrite ($bf,full_tag("TRACKENDENABLE",4,false,$tracker->trackendenable));
        fwrite ($bf,full_tag("TRACKSTART",4,false,$tracker->trackstart));
        fwrite ($bf,full_tag("TRACKEND",4,false,$tracker->trackend));
        fwrite ($bf,full_tag("LINKLABEL",4,false,$tracker->linklabel));
        fwrite ($bf,full_tag("TIMECREATED",4,false,$tracker->timecreated));
        fwrite ($bf,full_tag("TIMEMODIFIED",4,false,$tracker->timemodified));

        if (@$preferences->mods['coursetracking']->userinfo){
            $status = $status && coursetracking_backup_events($bf, $preferences, $tracker);
        }        

        //End mod
        $status = $status && fwrite ($bf,end_tag("MOD",3,true));

        return $status;
    }
    
    function coursetracking_backup_events($bf, $preferences, &$tracker){
        $status = true; 

        ////Iterate over coursetracking_event table
        $trackevents = get_records ('coursetracking_event','trackerid',$tracker->id,'id');
        if ($trackevents) {
            fwrite ($bf,start_tag("TRACKEVENTS",4,true));
            foreach ($trackevents as $trackevent) {
                //Start event
                fwrite ($bf,start_tag("TRACKEVENT",5,true));
                //Print coursetracking data
                fwrite ($bf,full_tag("ID",6,false,$trackevent->id));
                fwrite ($bf,full_tag("TRACKERID",6,false,$tracker->id));
                fwrite ($bf,full_tag("DOCUMENTID",6,false,$trackevent->documentid));
                fwrite ($bf,full_tag("MARKERID",6,false,$trackevent->markerid));
                fwrite ($bf,full_tag("USERID",6,false,$trackevent->userid));
                fwrite ($bf,full_tag("EVENT",6,false,$trackevent->event));
                fwrite ($bf,full_tag("EVENTCOUNT",6,false,$trackevent->eventcount));
                fwrite ($bf,full_tag("FIRSTOCCURRED",6,false,$trackevent->firstoccurred));
                fwrite ($bf,full_tag("LASTOCCURRED",6,false,$trackevent->lastoccurred));
                fwrite ($bf,full_tag("TOTALTIME",6,false,$trackevent->totaltime));
                fwrite ($bf,end_tag("TRACKEVENT",5,true));
            }
            fwrite ($bf,end_tag("TRACKEVENTS",4,true));
        }
                
        return $status;
    }
   
   ////Return an array of info (name,value)
   function coursetracking_check_backup_mods($courseid, $user_data=false, $backup_unique_code) {
        //First the course data
        $info[0][0] = get_string('modulenameplural', 'coursetracking');
        if ($ids = coursetracking_ids ($courseid)) {
            $info[0][1] = count($ids);
        } else {
            $info[0][1] = 0;
        }

        if ($user_data){
            $info[1][0] = get_string('events', 'coursetracking');
            if ($ids = coursetracking_event_ids ($courseid)) {
                $info[1][1] = count($ids);
            } else {
                $info[1][1] = 0;
            }
        }

        return $info;
    }

    //Return a content encoded to support interactivities linking. Every module
    //should have its own. They are called automatically from the backup procedure.
    function coursetracking_encode_content_links ($content,$preferences) {

        global $CFG;

        $base = preg_quote($CFG->wwwroot,"/");

        //Link to the list of coursetrackings
        $search = "/(".$base."\/mod\/coursetracking\/index.php\?id\=)([0-9]+)/";
        $result = preg_replace($search, '$@coursetrackingINDEX*$2@$', $content);

        //Link to coursetracking view by moduleid
        $search = "/(".$base."\/mod\/coursetracking\/view.php\?id\=)([0-9]+)/";
        $result = preg_replace($search, '$@coursetrackingVIEWBYID*$2@$', $result);

        return $result;
    }

    // INTERNAL FUNCTIONS. BASED IN THE MOD STRUCTURE

    //Returns an array of coursetrackings id
    function coursetracking_ids ($courseid) {
        global $CFG;
        
        $sql = "
            SELECT 
                a.id, 
                a.course
            FROM 
                {$CFG->prefix}coursetracking a
            WHERE 
                a.course = '$courseid'
        ";

        return get_records_sql ($sql);
    }

    //Returns an array of coursetrackings id
    function coursetracking_event_ids ($courseid) {
        global $CFG;
        
        $sql = "
            SELECT 
                e.id, 
                e.trackerid
            FROM 
                {$CFG->prefix}coursetracking a,
                {$CFG->prefix}coursetracking_event e
            WHERE 
                a.course = '$courseid' AND
                a.id = e.trackerid
        ";

        return get_records_sql ($sql);
    }
   
?>
