<?php
// This generator may be included directly by an include call, or invoked
// through an HTTP request.
if (@$wasIncluded == 0){
    require_once('../../../config.php');
    $u = optional_param('u', '*', PARAM_ALPHA);    // User id list if view is restricted
    $r = optional_param('r', '*', PARAM_ALPHA);    // Document URL or *
    $outputType = optional_param('outputType', 'GRAPHIC', PARAM_ALPHA);    // HTML or GRAPHIC
    $id = optional_param('id', 0, PARAM_INT);    // Course Module ID

    // get moodle context parameters
    if ($id) {
        if (! $cm = get_record('course_modules', 'id', $id)) {
            error('Course Module ID was incorrect');
        }
    
        if (! $coursetracker = get_record('coursetracking', 'id', $cm->instance)) {
            error("Coursetracker ID {$cm->instance} was incorrect");
        }
    
        if (! $course = get_record('course', 'id', $cm->course)) {
            error('Course is misconfigured');
        }
    } else {
        error('No valid parameters!!');
    }
}
$trace = 0;

//graphical inits
$CFG->systemfonts = "C:/WINNT/fonts/";
$verticalCurveStep = 24;
$graphWidth = 350;
$labelWidth = 350;
$ttffont = "Arial";

//tracing output for debugging
if ($trace) $TRACE = fopen("outputg.txt", "w");
if ($trace) fwrite($TRACE, "GRAPH $r\n" );

// if all resources are used, get resource list that match module's course
if ($r == '*'){
   $documentIds = get_records_menu('course_modules', 'course', $course->id, 'instance');
   $documentList = '';
   if ($documentIds)
      $documentList = implode("','", array_keys($documentIds));
} 
else{
   $documentList = $r;
}
// computes some extra clauses
$coursetrackerClause = ($coursetracker) ? " AND trackerid = {$coursetracker->id} " : '' ;
$userRestrictionClause = '';
if (isset($u) && $u != '*'){
    $u = str_replace(',', "','", $u);
    $userRestrictionClause = " AND te.userid IN ('{$u}') ";
}

if (!isset($test)){
    
    // getting sorted tracking events
    $query = "
        SELECT 
            r.name as name,
            te.*,
            cm.id as cmid,
            COUNT(IF(event = 'veni',1,NULL)) as venis, 
            COUNT(IF(event = 'vidi',1,NULL)) as vidis,
            COUNT(IF(event = 'vici',1,NULL)) as vicis 
        FROM 
            {$CFG->prefix}coursetracking_event as te,
            {$CFG->prefix}course_modules as cm,
            {$CFG->prefix}resource as r
        WHERE
            cm.id = te.documentid AND
            cm.instance = r.id AND
            documentid IN ('{$documentList}')
            $coursetrackerClause
            $userRestrictionClause
        GROUP BY
            documentid,markerid
        ORDER BY
            cmid,
            markerid
    ";
    if ($trace) fwrite($TRACE, $query . "\n");
    $results = mysql_query($query);
    $curves = array();
    $maxCountRange = 0;
    $lineCount = mysql_num_rows($results);

    // making curves data and metadata   
    while($aMarker = mysql_fetch_object($results)){
        unset($aCurveElement);
        $aCurveElement->name = $aMarker->name;
        $aCurveElement->id = $aMarker->markerid;
        $aCurveElement->venis = $aMarker->venis;   
        if ($maxCountRange < $aMarker->venis) $maxCountRange = $aMarker->venis;
        $aCurveElement->vidis = $aMarker->vidis;   
        $aCurveElement->vicis = $aMarker->vicis;   
        $aCurveElement->totaltime = $aMarker->totaltime;   
        $curves[$aMarker->documentid][] = $aCurveElement;
        $curvesData[$aMarker->documentid] = $aMarker->name;
    }
    
    // getting enroled students info
    $allStudentsInCourse = count(get_course_students($course->id));
}
else{
  include "testcurve.php";
}
if (count($curves) == 0){
    $textmessage = get_string('notrackingresults', 'coursetracking');
}
elseif (count($curves) < 1 && $outputType != 'HTML'){
    $textmessage = get_string('notenoughrecords', 'coursetracking');
}
/*
*
* This is the HTML Table non graphic output generation
*
*/
if ($outputType == 'HTML'){
    if (isset($textmessage)){
?>
        <span><?php echo $textmessage; ?></span>
<?php
    }
    foreach(array_keys($curves) as $aDocumentCurveId){
?>
        <h2><img src="<?php echo $CFG->wwwroot ?>/mod/resource/icon.gif">  <?php echo $curvesData[$aDocumentCurveId] ?></h2>
<?php
            unset($table);
            $table->head = array();
        	$table->head[0] = get_string('markerid', 'coursetracking');
        	$table->head[1] = "Veni";
        	$table->head[2] = "Vidi";
        	$table->head[3] = "Vici";
        	$table->align = array('left','center','center','center');
        	$table->size = array('40%','20%','20%','20%');
        	$table->wrap = array('','','','');
        	$table->class = '';
        	$table->fontsize = 2;
        	$table->tablealign = 'center';
        	$table->width = '80%';
        	$table->cellpadding = 2;
        	$table->cellspacing = 0;
        	$table->data = array();
        $i = 0;
        foreach($curves[$aDocumentCurveId] as $aCurveElement){
        	$table->data[$i][0] = "<img src=\"{$CFG->wwwroot}/mod/coursetracking/icon.gif\"> <a href=\"{$CFG->wwwroot}/mod/resource/view.php?id={$aDocumentCurveId}#lnk_{$aCurveElement->id}\">" . $aCurveElement->id . "</a>";
        	$table->data[$i][1] = $aCurveElement->venis; 
        	$table->data[$i][2] = $aCurveElement->vidis; 
        	$table->data[$i][3] = $aCurveElement->vicis; 
        	$i++;
        }
        echo make_table($table);
        unset($table);
    }
}
/*
*
* This is the GD generation alternative
*
*/
else{
	if ($trace) fwrite($TRACE, "entering in image production \n" );
    header("Content-type: image/png");
  
  // Searching for font files
  $fontFile = $CFG->dirroot . "/mod/coursetracking/fonts/arial.ttf";
  // if fonts where not given by module, try with site fonts, then system fonts.
  if (!file_exists($fontFile))
    $fontFile = $CFG->dirroot . "/fonts/{$ttffont}.ttf";
  if (!file_exists($fontFile))
    $fontFile = @$CFG->systemfonts . "{$ttffont}.ttf";

	if ($trace) fwrite($TRACE, "font file is $fontFile \n" );

    if (isset($textmessage)){
        $bounds = imagettfbbox(14, 0, $fontFile, $textmessage);
        $imageWidth = $bounds[2] - $bounds[0] + 2;
        $imageHeight = ($bounds[1] - $bounds[7]) * 1.4;
    }
    else{
        $imageWidth = $graphWidth + $labelWidth + 10;
        $imageHeight = $verticalCurveStep * ($lineCount + 1) + 30;
    }

	 if ($trace) fwrite($TRACE, "bounds calculated size ($imageWidth,$imageHeight)\n" );

    $im = imagecreatetruecolor($imageWidth, $imageHeight) or fwrite($TRACE, "image buffer failure \n" );

	 if ($trace) fwrite($TRACE, "image buffer created \n" );

    imageantialias($im, TRUE);

	 if ($trace) fwrite($TRACE, "antialiased is set\n" );

    // Assigning colors
    $colors['black'] = imagecolorallocate($im, 0, 0, 0);
    $colors['green'] = imagecolorallocate($im, 0, 200, 0);
    $colors['yellow'] = imagecolorallocate($im, 230, 230, 0);
    $colors['red'] = imagecolorallocate($im, 200, 0, 0);
    $colors['white'] = imagecolorallocate($im, 240, 240, 240);
    $colors['gray'] = imagecolorallocate($im, 150, 150, 150);
    $colors['blue'] = imagecolorallocate($im, 0, 0, 180);
    
	 if ($trace) fwrite($TRACE, "colors allocated \n" );

    imagefilledrectangle($im, 0, 0, $imageWidth, $imageHeight, $colors['white']);  

    if (!isset($textmessage)){
        // Creating graph
		  if ($trace) fwrite($TRACE, "generating graph\n" );

        // Creating title
        imagettftext($im, 18, 0, 10, 26, $colors['black'], $fontFile, $u);
        imagettftext($im, 14, 0, $imageWidth - 120, 26, $colors['black'], $fontFile, get_string('students', 'coursetracking') . ' : ' . $maxCountRange);
    
        // Mark list
        $y = $verticalCurveStep;
        $i = 1;
        $titlesize = max(9, floor($verticalCurveStep / 3));
        $markersize = max(7, floor($verticalCurveStep / 3) - 2);
        foreach(array_keys($curves) as $aDocument){            
            imagettftext($im, $titlesize, 0, 5, $y + floor($verticalCurveStep / 2), $colors['blue'], $fontFile, $curves[$aDocument][0]->name);
            foreach($curves[$aDocument] as $aCurveElement){
                $y = floor(30 + ($verticalCurveStep * $i) + $verticalCurveStep / 4);
                imagettftext($im, $markersize, 0, 25, $y, $colors['black'], $fontFile, $aCurveElement->id);
                $i++;
            }
        }
    
        imagefilledrectangle($im, $labelWidth + 10, 30, $imageWidth, $imageHeight, $colors['gray']);
    
        // veni curve
        $polygon = array();
        $polygon[] = $labelWidth + 10;
        $polygon[] = 30;
        $i = 1;
        foreach(array_keys($curves) as $aDocument){
            foreach($curves[$aDocument] as $aCurveElement){
                $polygon[] = $labelWidth + 10 + $aCurveElement->venis / $maxCountRange * $graphWidth;
                $polygon[] = 30 + ($verticalCurveStep * $i);
                $i++;
            }
        }
        $polygon[] = $labelWidth + 10;
        $polygon[] = $imageHeight;
        $i++;
        imagefilledpolygon ($im, $polygon, $i, $colors['red']);
    
        // vidi curve
        $polygon = array();
        $polygon[] = $labelWidth + 10;
        $polygon[] = 30;
        $i = 1;
        foreach(array_keys($curves) as $aDocument){
            foreach($curves[$aDocument] as $aCurveElement){
                $polygon[] = $labelWidth + 10 + $aCurveElement->vidis / $maxCountRange * $graphWidth;
                $polygon[] = 30 + ($verticalCurveStep * $i);
                $i++;
            }
        }
        $polygon[] = $labelWidth + 10;
        $polygon[] = $imageHeight;
        $i++;
        imagefilledpolygon ($im, $polygon, $i, $colors['yellow']);
    
        // vici curve
        $polygon = array();
        $polygon[] = $labelWidth + 10;
        $polygon[] = 30;
        $i = 1;
        foreach(array_keys($curves) as $aDocument){
            foreach($curves[$aDocument] as $aCurveElement){
                $polygon[] = $labelWidth + 10 + $aCurveElement->vicis / $maxCountRange * $graphWidth;
                $polygon[] = 30 + ($verticalCurveStep * $i);
                $i++;
            }
        }
        $polygon[] = $labelWidth + 10;
        $polygon[] = $imageHeight;
        $i++;
        imagefilledpolygon ($im, $polygon, $i, $colors['green']);
      
        // lignes horizontales
        imagesetthickness($im, 1);
        $i = 1;
        foreach(array_keys($curves) as $aDocument){
            foreach($curves[$aDocument] as $aCurveElement){
                $y = 30 + ($verticalCurveStep * $i);
                imageline($im, $labelWidth + 10, $y, $imageWidth, $y, $colors['blue']);
                $i++;
            }
        }
    }
    else{
		  if ($trace) fwrite($TRACE, "generating text\n" );
        imagettftext($im, 12, 0, 5, $imageHeight - 4, $colors['black'], $fontFile, $textmessage);
    }

  // delivering image
  imagepng($im);
  imagedestroy($im);
  if ($trace) fclose($TRACE);
}
?>