<?php
require_once('../../../config.php');
$id = required_param('id', PARAM_INT);    // coursemodule id
$u = optional_param('u', '*', PARAM_CLEAN);    // User id list if view is restricted
$r = optional_param('r', '*', PARAM_CLEAN);    // Document URL or *

error_reporting(7);

// get moodle context parameters
if ($id) {
    if (! $cm = get_record('course_modules', 'id', $id)) {
        error('Course Module ID was incorrect');
    }

    if (! $coursetracker = get_record('coursetracking', 'id', $cm->instance)) {
        error("Coursetracker ID {$cm->instance} was incorrect");
    }

    if (! $course = get_record('course', 'id', $cm->course)) {
        error('Course is misconfigured');
    }
} 
else {
    error('No valid parameters!!');
}

global $TRACE;
global $trace;
$trace = 1;

// document restriction
if ($r == '*'){
   $documentRestrictionClause = '';
} 
else{
   $documentList = str_replace(",", "','", $r);
   $documentRestrictionClause = "AND documentid IN ('{$documentList}') ";
}

// user restriction
$userRestrictionClause = '';
if (isset($u) && $u != '*'){
    $u = str_replace(',', "','", $u);
    $userRestrictionClause = " AND userid IN ('{$u}') ";
}


if ($trace) $TRACE = fopen("outputxml.txt", "a");
if ($trace) fwrite($TRACE, $query . "\n");

// get events
$query = "
    SELECT
        *
    FROM 
        {$CFG->prefix}coursetracking_event as te
    WHERE
        trackerid = $coursetracker->id
        $documentRestrictionClause
        $userRestrictionClause
    ORDER BY
        firstoccurred
";
if ($trace) fwrite($TRACE, $query . "\n");
$events = get_records_sql($query);

$userset = array();
$documentset = array();
foreach($events as $anEvent){
    array_push($userset, $anEvent->userid);
    // events have recorded the course_module id
    array_push($documentset, $anEvent->documentid);
}

$userIds = implode("','", $userset);

// get users
$query = "
   SELECT
       id,
       username,
       lastname,
       firstname
   FROM
       {$CFG->prefix}user
   WHERE
       id IN ('$userIds') 
";
$users = get_records_sql($query);

$documentIds = implode("','", array_unique($documentset));

// get documents
$query = "
   SELECT
       cm.id,
       cm.instance,
       m.name as modulename
   FROM
       {$CFG->prefix}course_modules as cm,
       {$CFG->prefix}modules as m
   WHERE
       cm.module = m.id AND
       cm.id IN ('$documentIds') 
";
$modules = get_records_sql($query);

// get documents
$documents = array();
foreach($modules as $aModule){
    $query = "
       SELECT
         '{$aModule->id}' as module,
         id,
         name
       FROM
           {$CFG->prefix}{$aModule->modulename}
       WHERE
           id = $aModule->instance
    ";
    $documents[] = get_record_sql($query);
}

// XML Production
$eventtypes = array();
$eventtype->name = 'veni';
$eventtypes[] = $eventtype;
unset($eventtype);
$eventtype->name = 'vidi';
$eventtypes[] = $eventtype;
unset($eventtype);
$eventtype->name = 'vici';
$eventtypes[] = $eventtype;

$xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
$xml .= "<coursetracking>\n";
$xml .= xmlize_as_elements('coursetracker', $coursetracker, 1);
$xml .= xmlize_as_attributes('eventtype', $eventtypes, 1);
$xml .= xmlize_as_attributes('event', $events, 1);
$xml .= xmlize_as_attributes('user', $users, 1);
if ($documents)
    $xml .= xmlize_as_attributes('document', $documents, 1);
$xml .= "</coursetracking>\n";

echo $xml;

function xmlize_as_elements($name, $object, $order){
   $prefix = str_repeat("\t", $order);
   $xml = "{$prefix}<{$name}>\n";
   $modulehash = get_object_vars($object);
   foreach($modulehash as $aKey => $aValue)
      $xml .= "{$prefix}\t<{$aKey}>".$aValue."</{$aKey}>\n";
   $xml .= "{$prefix}</$name>\n";   
   return $xml;
}

function xmlize_as_attributes($name, $objectset, $order){
    $prefix = str_repeat("\t", $order);
    if (empty($objectset)) return "{$prefix}<{$name}s>\n{$prefix}</{$name}s>\n";
    if (is_array($objectset)){
        $xml = "{$prefix}<{$name}s>\n";
        foreach($objectset as $anObject){
            $xml .= "{$prefix}\t<$name";
            $modulehash = get_object_vars($anObject);
            foreach($modulehash as $aKey => $aValue)
                $xml .= " {$aKey}=\"".$aValue."\"";
            $xml .= " />\n";
        }
        $xml .= "{$prefix}</{$name}s>\n";   
    }
    else{
        $xml = "{$prefix}\t<{$name}";
        $modulehash = get_object_vars($objectset);
        foreach(array_keys($modulehash) as $aKey)
            $xml .= " {$aKey}=\"".$modulehash[$aKey]."\"";
        $xml .= " />\n";
    }
    return $xml;
}
?>