<?php  // $Id: lib.php,v 1.1.2.2 2009/12/31 17:04:02 diml Exp $

/// Library of functions and constants for module coursetracking

/**
*  Given an object containing all the necessary data,
* (defined by the form in mod.html) this function
* will create a new instance and return the id number
* of the new instance.
*/
function coursetracking_add_instance($coursetracker){

    $coursetracker->timemodified = time();
    $coursetracker->timecreated = time();
    
    if ($returnid = insert_record('coursetracking', $coursetracker)) {
        coursetracking_update_events($coursetracker);
    }

    return $returnid;
}

/**
* Given an object containing all the necessary data, 
* (defined by the form in mod.html) this function 
* will update an existing instance with new data.
*/
function coursetracking_update_instance($coursetracker){
    global $CFG;

    $coursetracker->timemodified = time();
    $coursetracker->id = $coursetracker->instance;

    if ($returnid = update_record('coursetracking', $coursetracker)) {
        coursetracking_update_events($coursetracker);
    }
    return $returnid;

}

/**
* Updates or create calendar events related to this module
*/
function coursetracking_update_events(&$coursetracker){
    $dates = array(
        'coursetrackingstart' => $coursetracker->timestart,
        'coursetrackingend' => $coursetracker->timeend,
        'trackingstart' => $coursetracker->capturestart,
        'trackingend' => $coursetracker->captureend
    );

    $moduleid = get_field('modules', 'id', 'name', 'coursetracking');
    
    foreach ($dates as $type => $date) {
        if ($event = get_record('event', 'modulename', 'coursetracking', 'instance', $coursetracker->id, 'eventtype', $type)) {
            $event->name        = get_string($type.'event','coursetracking', $coursetracker->name);
            $event->description = $coursetracker->description;
            $event->eventtype   = $type;
            $event->timestart   = $date;
            update_event($event);
        } else if ($date) {
            $event = NULL;
            $event->name        = get_string($type.'event','coursetracking', $coursetracker->name);
            $event->description = $coursetracker->description;
            $event->courseid    = $coursetracker->course;
            $event->groupid     = 0;
            $event->userid      = 0;
            $event->modulename  = 'coursetracking';
            $event->instance    = $coursetracker->instance;
            $event->eventtype   = $type;
            $event->timestart   = $date;
            $event->timeduration = 0;
            $event->visible     = get_field('course_modules', 'visible', 'module', $moduleid, 'instance', $coursetracker->id); 
            add_event($event);
        }
    }
} 

/**
* Given an ID of an instance of this module,
* this function will permanently delete the instance
* and any data that depends on it.
*/
function coursetracking_delete_instance($id){

    if (! $coursetracker = get_record('coursetracking', 'id', $id)) {
        return false;
    }

    $result = true;

    /* Delete any dependent records here */
    if (! delete_records('coursetracking_event', 'trackerid', $coursetracker->id)) {
        $result = false;
    }

    if (! delete_records('coursetracking', 'id', $coursetracker->id)) {
        $result = false;
    }

	/* Delete any event associate with the coursetracking */
    if (! delete_records('event', 'modulename', 'coursetracking', 'instance', $coursetracker->id)) {
        $result = false;
    }

    return $result;
}

/**
*/
function coursetracking_user_outline($course, $user, $mod, $coursetracker){
    return NULL;
}

/**
*/
function coursetracking_cron(){

}


/**
*
*/
function coursetracking_print_recent_activity($course, $isteacher, $timestart){
/// Given a list of logs, assumed to be those since the last login
/// this function prints a short list of changes related to this module
/// If isteacher is true then perhaps additional information is printed.
/// This function is called from course/lib.php: print_recent_activity()
    global $CFG;

    return false;
}

/**
 * Course resetting API
 * Called by course/reset.php
 */
function coursetracking_reset_course_form($course) {
    echo get_string('resettrackers', 'coursetracking'); echo ':<br />';
    print_checkbox('reset_tracker_events', 1, true, get_string('trackerevents','coursetracking'), '', '');  echo '<br />';
    echo '</p>';
}

/**
* This function is used by the remove_course_userdata function in moodlelib.
* If this function exists, remove_course_userdata will execute it.
* This function will remove all posts from the specified forum.
* @param data the reset options
* @return void
*/
function coursetracking_delete_userdata($data, $showfeedback = true) {
    global $CFG;
    
    $query = "
        DELETE FROM 
            {$CFG->prefix}coursetracking_event
        WHERE 
            trackerid 
        IN ( SELECT 
                c.id 
             FROM 
                {$CFG->prefix}coursetracking AS c
             WHERE 
                c.course={$data->courseid} )
    ";

    $strreset = get_string('reset');

    if (!empty($data->reset_tracker_events)) {
        if (execute_sql($query, false) and $showfeedback) {
            notify($strreset.': '.get_string('trackerevents','coursetracking'), 'notifysuccess');
        }
    }

}

?>
