<?php
    $lastmodified = filemtime("tracker.php");
    $lifetime = 1800;

    // header("Content-type: application/x-javascript");  // Correct MIME type
    header("Last-Modified: " . gmdate("D, d M Y H:i:s", $lastmodified) . " GMT");
    header("Expires: " . gmdate("D, d M Y H:i:s", time() + $lifetime) . " GMT");
    header("Cache-control: max_age = $lifetime");
    header("Pragma: ");

    include_once("../../../../../config.php");

    $lang = current_language();

    if (empty($lang)) {
        $lang = "en";
    }

    // get some parameters
    $id = optional_param('id', 0, PARAM_INT); // courseId
    
    $trackers = get_records('coursetracking', 'course', $id);

?>
// Tracker Plugin for HTMLArea-3.0
// Implementation by Valery Fremaux.  Sponsored by no one
//
// htmlArea v3.0 - Copyright (c) 2002 interactivetools.com, inc.
// This notice MUST stay intact for use (see license.txt).
//
// A free WYSIWYG editor replacement for <textarea> fields.
// For full source code and docs, visit http://www.interactivetools.com/
//
// Version 3.0 developed by Mihai Bazon for InteractiveTools.
//   http://dynarch.com/mishoo
//
// $Id: tracker.php,v 1.1.2.1 2009/12/28 19:12:29 diml Exp $

function Tracker(editor) {
	this.editor = editor;

	var cfg = editor.config;
	cfg.tracking = true;
	var tt = Tracker.I18N;
	var self = this;

	cfg.registerButton("CT-track", tt["Tracker properties"], editor.imgURL("insertTracker.gif", "Tracker"), false,
			   function(editor, id) {
				   self.buttonPress(editor, id);
			   });

	// add a new line in the toolbar
	if (!isFirefox()){
    	cfg.toolbar[0].splice(0, 0, "separator");
    	cfg.toolbar[0].splice(0, 0, "CT-track");
    } else {
        cfg.toolbar[0][cfg.toolbar.length] = "separator";
        cfg.toolbar[0][cfg.toolbar.length] = "CT-track";
    }
};

Tracker._pluginInfo = {
	name          : "Content Tracker",
	version       : "1.0",
	developer     : "Valery Fremaux",
	developer_url : "http://www.ethnoinformatique.fr/",
	c_owner       : "Valery Fremaux",
	sponsor       : "None.",
	sponsor_url   : "",
	license       : "htmlArea"
};

Tracker.prototype.buttonPress = function(editor, id) {
	var self = this;
	switch (id) {
	    case "CT-track" : {

    		var trackerId = 'preset default identifier';
    		var triggerDelay = 5;
    		var triggerMode = "auto";
    		var trackerDefs = new Array();
    		var trackerAlign = "false";
    		var trackerDefIds = new Array();
    		var trackerDefOptions = new Array();
    		trackerDefs[0] = 0;
<?php
if ($trackers){
    $i = 0;
    foreach($trackers as $aTracker){
        echo "\t\ttrackerDefIds[{$i}] = '{$aTracker->id}';\n";
        echo "\t\ttrackerDefOptions[{$i}] = '{$aTracker->name}';\n";
        $i++;
    }
} 
?> 		 
    		trackerDefs[1] = trackerDefIds;
    		trackerDefs[2] = trackerDefOptions;

	        // try to get actual values for the selected image if selected area is a tracker
	        // then override default values
    		var doc = editor._doc;
            var sel = this.editor._getSelection();
            var aRange = this.editor._createRange(sel);
            if (aRange && aRange != ''){
                if (isGecko()){
                    image = this.editor._createRange(sel).commonAncestorContainer.firstChild;
                    // tries to find a marker in the selection
                    if (image != null){
                        while(!(image != null && image.tagName == 'IMG' && image.alt.match(/^mark:/))){
                            image = image.nextSibling;
                        }
                    }
                }
                else{
                    // this is a controlRange
                    if (sel.type == "Control")
                        var image = aRange.item(0);
                    else
                        image = null;
                }
                if (image && image.tagName == 'IMG' && image.alt.match(/^mark:/)) {
                    trackerAlign = image.align;
                    parms = image.alt.split(/:/);
                    switch(parms.length){
                        case 5: trackerMode = parms[4];
                        case 4: triggerDelay = parms[3];
                        case 3: trackerId = parms[2];
                        case 2: trackerDefs[0] = parms[1];
                    }
                }
            }

    		var init = {
    			f_identifier            : trackerId,
    			f_vidiMode              : triggerMode,
    			f_vidiTriggerDelay      : triggerDelay,
    			f_align                 : trackerAlign,
    			f_tracker               : trackerDefs
    		};
    		editor._popupDialog("plugin://Tracker/trackerprop", function(params) {
    			self.setTrackerProperties(params);
    		}, init);
    		break;
    	}
	}
};

Tracker.prototype.setTrackerProperties = function(params) {
	var doc = this.editor._doc;
    var sel = this.editor._getSelection();
    var range = this.editor._createRange(sel);
    var editor = this.editor;  // for nested functions
	var cfg = editor.config;
	// TODO : do what you have to do on closing popup
	// create the img element
    var trackerObject = doc.createElement("img");
    trackerObject.className = "teachertracker";
    trackerObject.src = "<?php echo $CFG->wwwroot ?>/mod/coursetracking/pix/tracker.gif";
    /*
    if (HTMLArea.is_ie) {
        trackerObject.src = "<?php echo $CFG->wwwroot ?>/mod/coursetracking/pix/tracker.gif";
    }
    else{
        trackerObject.src = "mod/coursetracking/pix/tracker.gif";
    }*/
    // assign the given arguments
    trackerObject.alt = "mark:" + params["f_tracker"]+ ":" + params["f_identifier"];
    if (params["f_vidiTriggerDelay"]  != ''){
    	trackerObject.alt +=  ":" + params["f_vidiTriggerDelay"];
    }
    if (params["f_vidiMode"]  != ''){
    	trackerObject.alt +=  ":" + params["f_vidiMode"];
    }
    if (params['f_align'] == "right"){
        // cause of Mozilla
    	eval("trackerObject.align = 'right';");
    }

    // add tag to document or change values
    if (HTMLArea.is_ie) {
        if (sel.type != "Control"){
            range.pasteHTML(trackerObject.outerHTML);
        }
        else{
            image = range.item(0);
            image.alt = trackerObject.alt;
            image.align = trackerObject.align;
        }
    } 
    else {
        // insert the div marker
        editor.insertNodeAtSelection(trackerObject);
    }
    return true;
};

function isFirefox(){
  re = /Firefox/i;
  if (navigator.userAgent.match(re)) return true;
  return false;
}
function isGecko(){
  re = /Gecko/i;
  if (navigator.userAgent.match(re)) return true;
  return false;
}
