<?php  // $Id: locallib.php,v 1.1.2.2 2009/12/31 17:02:02 diml Exp $

// constant defines for module options
define('GRAPHIC', 0);
define('HTML', 1);

/// Library of extra functions and module project

function coursetracking_print_info($coursetracker) {
    global $CFG;

    if (! $course = get_record("course", "id", $coursetracker->course)) {
        error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance("coursetracking", $coursetracker->id, $course->id)) {
        error("Course Module ID was incorrect");
    }
    // print standard assignment heading
    print_heading(format_string($coursetracker->name), "center");
    print_simple_box_start("center");

    // get some data
    $query = "
       SELECT
          COUNT(DISTINCT(markerid))
       FROM
          {$CFG->prefix}coursetracking_event
       WHERE
          trackerid = {$coursetracker->id}
    ";
    $totalmarkers = count_records_sql($query);    

    $query = "
       SELECT
          COUNT(*)
       FROM
          {$CFG->prefix}coursetracking_event
       WHERE
          trackerid = {$coursetracker->id}
    ";
    $totalrecordsabsolute = count_records_sql($query);

    $query = "
       SELECT
          COUNT(*)
       FROM
          {$CFG->prefix}coursetracking_event
       WHERE
          trackerid = {$coursetracker->id} AND
          firstoccurred > {$coursetracker->trackstart} AND
          firstoccurred < {$coursetracker->trackend}
    ";
    $totalcompilablerecords = count_records_sql($query);

    $query = "
       SELECT
          COUNT(DISTINCT(userid))
       FROM
          {$CFG->prefix}coursetracking_event
       WHERE
          trackerid = {$coursetracker->id}
    ";
    $totalstudents = count_records_sql($query);    

    $query = "
       SELECT
          SUM(totaltime) as totalviewtime
       FROM
          {$CFG->prefix}coursetracking_event
       WHERE
          trackerid = {$coursetracker->id}
       GROUP BY 
          trackerid
    ";
    $result = get_record_sql($query);
    $totalviewtime = ($result) ? 0 + $result->totalviewtime : 0 ;

    if($coursetracker->trackstartenable || $coursetracker->trackendenable){   
        $compilablelabel = "<b>" . get_string('totalcompilablerecords', 'coursetracking') . ":</b>";
    }
    else{
        $compilablelabel = "<span class=\"shadowed\"><b>" . get_string('totalcompilablerecords', 'coursetracking') . ":</b></span>";
        $totalcompilablerecords = "<span class=\"shadowed\">{$totalrecordsabsolute}</span>";
    }

    unset($table);
    $table->head = array('','','');
	$table->align = array('left', 'left', 'left');
	$table->size = array('40%', '30%', '10%');
	$table->wrap = array('', 'nowrap', '');
    $table->data = array(array("<b>" . get_string('coursetrackerlabel', 'coursetracking') . ":</b>", $coursetracker->linklabel, helpbutton('trackerlabel', get_string('trackerlabel', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('timestart', 'coursetracking') . ":</b>", userdate($coursetracker->timestart), helpbutton('timerange', get_string('timerange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('timeend', 'coursetracking') . ":</b>", userdate($coursetracker->timeend), helpbutton('timerange', get_string('timerange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('capturestart', 'coursetracking') . ":</b>", userdate($coursetracker->capturestart), helpbutton('capturerange', get_string('capturerange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('captureend', 'coursetracking') . ":</b>", userdate($coursetracker->captureend), helpbutton('capturerange', get_string('capturerange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('trackstart', 'coursetracking') . ":</b>", userdate($coursetracker->trackstart), helpbutton('compilationrange', get_string('trackrange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('trackend', 'coursetracking') . ":</b>", userdate($coursetracker->trackend), helpbutton('compilationrange', get_string('trackrange', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('totalrecordsabsolute', 'coursetracking') . ":</b>", $totalrecordsabsolute, helpbutton('totalrecords', get_string('totalrecords', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('trackview', 'coursetracking') . "</b>", view_compilation_range($coursetracker), ''),
        array($compilablelabel, $totalcompilablerecords, helpbutton('totalrecords', get_string('totalrecords', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('totalmarkers', 'coursetracking') . ":</b>", $totalmarkers, helpbutton('totalmarkers', get_string('totalmarkers', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('totalusers', 'coursetracking') . ":</b>", $totalstudents, helpbutton('totalusers', get_string('totalusers', 'coursetracking'), 'coursetracking', true, false, '', true)),
        array("<b>" . get_string('totalviewtime', 'coursetracking') . ":</b>", $totalviewtime . " sec(s)", helpbutton('totalviewtime', get_string('totalviewtime', 'coursetracking'), 'coursetracking', true, false, '', true))); 
	$table->class = '';
	$table->fontsize = 2;
	$table->tablealign = 'center';
	$table->width = '80%';
	$table->cellpadding = 5;
	$table->cellspacing = 5;
    echo make_table($table);
    unset($table);

    print_simple_box_end();
}

/**
* display a graphical bargraph showing time windows.
*/
function view_compilation_range($coursetracker){
    global $CFG;
    
    $trackwidth = 400;

    // define scale for capture range
    $course = get_record('course', 'id', $coursetracker->id);
    $scale = 0;
    if ($coursetracker->timeendenable && $coursetracker->timestartenable)
        $scale = $coursetracker->timeend - $coursetracker->timestart;
    else if ($coursetracker->timeendenable && !$coursetracker->timestartenable)
        $scale = $coursetracker->timeend - $course->timecreated;
    else if (!$coursetracker->timeendenable && $coursetracker->timestartenable)
        $scale = usertime() - $coursetracker->timestart;

    // compute compile range limits against scale borders
    if (!$coursetracker->trackstartenable){
        $trackstart = 0;
    }
    else{
        $trackstart = $coursetracker->trackstart - $coursetracker->timestart;
    }
    if (!$coursetracker->trackendenable){
        $trackend = $scale;
    }
    else{
        $trackend = $coursetracker->trackend - $coursetracker->timestart;
    }
    // echo $trackstart . "  -  " . $trackend . "  -  " . $scale;
    $image1width = (($scale * $trackwidth) != 0) ? $trackstart / $scale * $trackwidth : 0 ;
    $image2width = (($scale * $trackwidth) != 0) ? ($trackend - $trackstart) / $scale * $trackwidth : $trackwidth ;
    $image3width = (($scale * $trackwidth) != 0) ? ($scale - $trackend) / $scale * $trackwidth : 0 ;
    $outputbuffer = "<img src=\"{$CFG->wwwroot}/mod/coursetracking/pix/blue.gif\" width=\"{$image1width}\" height=10 style=\"display : inline\" /><img src=\"{$CFG->wwwroot}/mod/coursetracking/pix/green.gif\" width=\"{$image2width}\" height=10 style=\"display : inline\" /><img src=\"{$CFG->wwwroot}/mod/coursetracking/pix/blue.gif\" width=\"{$image3width}\" height=10 style=\"display : inline\" />";
    return $outputbuffer;
}
?>