<?php  // $Id: view.php,v 1.1.2.1 2009/12/28 19:12:18 diml Exp $

/// This page prints a particular instance of a coursetracker

    require_once('../../config.php');
    require_once($CFG->libdir.'/tablelib.php');
    require_once('lib.php');
    require_once('locallib.php');

    $timenow = time();
    
    $id = required_param('id', PARAM_INT);

    // MVC control
    if (!isset($SESSION->currentview)) $SESSION->currentview = '';
    $SESSION->currentview = $view = optional_param('view', $SESSION->currentview, PARAM_ALPHA);
    $action = optional_param('cmd', '', PARAM_ALPHA);
    // 
    
    // get some useful stuff...
    if (! $cm = get_record('course_modules', 'id', $id)) {
        error("Course Module ID was incorrect");
    }
    if (! $course = get_record('course', 'id', $cm->course)) {
        error("Course is misconfigured");
    }
    if (! $coursetracker = get_record('coursetracking', 'id', $cm->instance)) {
        error("Course module is incorrect");
    }

    require_login($course->id, false, $cm);

    $strcoursetrackings = get_string('modulenameplural', 'coursetracking');
    $strcoursetracking  = get_string('modulename', 'coursetracking');
    $straction = ($action) ? '-> '.get_string($action, 'coursetracking') : '';
    
    $context = get_context_instance(CONTEXT_MODULE, $cm->id);

    // ...display header...
    print_header_simple(format_string($coursetracker->name), '',
                 "<a href=\"index.php?id=$course->id\">$strcoursetrackings</a> ->
                  <a href=\"view.php?id=$cm->id\">".format_string($coursetracker->name,true)."</a> $straction",
                  '', '', true, update_module_button($cm->id, $course->id, $strcoursetracking), navmenu($course, $cm));

    // ... get resource constraint...

    $rs  = optional_param('rs', '', PARAM_INT);  // Resource Id if single view

    // ...and if necessary set default action
    if (has_capability('mod/coursetracking:canseeindividualdata', $context)) {
        if (empty($action)) { // no action specified, either go straight to elements page else the admin page
            if ($rs == ''){
			    $action = 'teachersview';
			}
			else{
			    $action = 'teachersingle';
			}
        }
    }
    elseif (!isguest()) { // it's a student then
        if (!$cm->visible) {
            notice(get_string('activityiscurrentlyhidden'));
        }
		if ($timenow < $coursetracker->timestart) {
			$action = 'notavailable';
		} else if (!$action) {
			if ($timenow < $coursetracker->timeend) {
				$action = 'studentsview';
			} else {
				$action = 'captureperiodclosed';
			}
		}
    } else { // it's a guest, oh no!
        $action = 'notavailable';
    }

    // ...log activity...
    add_to_log($course->id, 'coursetracking', 'view', "view.php?id=$cm->id", $coursetracker->id, $cm->id);

    /****************** display final grade (for students) ************************************/
    if ($action == 'captureperiodclosed' ) {
    	echo get_string('captureperiodclosed', 'coursetracking');
		// include("globalpublicstats.php");
    }
    
    /****************** module not available (for students or guests)***********************/
    elseif ($action == 'notavailable') {
        print_heading(get_string('notavailable', 'coursetracking'));
    }


    /****************** student's view  ***********************/
    elseif ($action == 'studentsview') {
        
    	if (!$groupmode = groupmode($course, $cm)){
    		$currentgroup = 0;
    	} 
    	else {
    		$currentgroup = get_current_group($course->id);
    	}
    	
    	if (!$currentgroup) {
    	    // groups are not enabled OR I am not in group
			include('viewme.php');
    	} 
    	else if ($groupemode == SEPARATEGROUPS && $currentgroup) {
			include('viewmygroup.php');
		}
    	else if ($groupemode == VISIBLEGROUPS && $currentgroup) {
			include('viewallgroups.php');
		}
    }

    /****************** teacher's view - display admin page  ************/
    elseif (($action == 'changeFilterSettings') || ($action == 'teachersview')) {
        
        // teacher has access to a general reporting board, whatever the situation
        // of groups.
        // TODO : think about being group aware for reporting.

        /// Check to see if groups are being used in this workshop
        /// and if so, set $currentgroup to reflect the current group
        $changegroup = isset($_GET['group']) ? $_GET['group'] : -1;  // Group change requested?
        $groupmode = groupmode($course, $cm);   // Groups are being used?
        $currentgroup = get_and_set_current_group($course, $groupmode, $changegroup);    
    
        /// Print settings and things in a table across the top
        echo '<table width="100%" border="0" cellpadding="3" cellspacing="0"><tr valign="top">';

        /// Allow the teacher to change groups (for this session)
        if ($groupmode and has_capability('moodle/course:manageactivities', $context)) {
            if ($groups = get_records_menu('groups', 'courseid', $course->id, 'name ASC', 'id,name')) {
                echo '<td>';
                print_group_menu($groups, $groupmode, $currentgroup, "view.php?id={$cm->id}");
                echo '</td>';
            }
        }    	
        echo '</table>';    
    	
    	if (empty($currentgroup)){
    		$currentgroup = 0;
    	}
    	include('teachersview.php');
    	
	}
    elseif ($action == 'teachersingle') {
    	include('viewSingleResource.php');
    }

    /****************** show description  ************/
    elseif ($action == 'showdescription') {
        project_print_assignment_info($coursetracker);
        print_simple_box(format_text($coursetracker->description, $coursetracker->format), 'center', '70%', '', 5, 'generalbox', 'intro');
        print_continue($_SERVER["HTTP_REFERER"]);
    }

    /*************** student is not in a group **************************************/
    elseif ($action == 'notingroup') {
		print_simple_box(format_text(get_string('notingroup', 'coursetracking'), $coursetracker->format), 'center', '70%', '', 5, 'generalbox', 'intro');
		print_continue($_SERVER["HTTP_REFERER"]); 
    }    
    

    /*************** no man's land **************************************/
    else {
        error("Fatal Error: Unknown Action: ".$action."\n");
    }


    print_footer($course);

?>